SuperStrict

Graphics 800,600

AppTitle="Chaos Hack"

Global J:TJ,V:TV,KeyStroke%[ 256 ]

Global CurrDepth%

Init()

Local Timer:TTimer = CreateTimer(60)

While Not (KeyHit(KEY_ESCAPE) Or AppTerminate())
Local ImportantStroke%

For Local I% = EachIn [ KEY_LEFT,KEY_RIGHT,KEY_UP,KEY_DOWN,KEY_0,KEY_1,KEY_2,KEY_3,KEY_4,KEY_5,KEY_6,KEY_7,KEY_8,KEY_9,KEY_T,KEY_D ]
KeyStroke[ I ] = KeyHit(I)

ImportantStroke :+ KeyStroke[ I ]
Next

If ImportantStroke Then V.UserInput()

WaitTimer Timer
Wend
End

Function Init()
CurrDepth = 0

J = New TJ

TScenario.Load()

?Win32
SetImageFont LoadImageFont(getenv_("WINDIR") + "\Fonts\lucon.ttf",14,BOLDFONT)
?MacOS
SetImageFont LoadImageFont("/System/Library/Fonts/Menlo.ttc")
?

V.UpdateWorld()
End Function

Function Render()
V.D.Render()
End Function

Function ContainerFunc%(L:Byte Ptr)
Local N$ = lua_tostring(L,1)

lua_remove(L,1)

Select N
Case "DrawText"
Local Text$ = lua_tostring(L,1)
Local X#     = lua_tonumber(L,2)
Local Y#     = lua_tonumber(L,3)

DrawText Text,X,Y
Case "SetColor"
SetColor lua_tonumber(L,1),lua_tonumber(L,2),lua_tonumber(L,3)
Case "CreateObject"
Local Q:TQ = TQ.CreateFromLua(lua_tostring(L,1),TLevel.CurrD)

Q.TileX = lua_tonumber(L,2)
Q.TileY = lua_tonumber(L,3)

Q.D.PO(Q)

lua_getglobal(L,Q.Name)

Return 1
Case "PrepareDungeon"
TLevel.CurrD = TD.Prepare(lua_tonumber(L,1),lua_tonumber(L,2))
Case "SyncObject"
lua_getfield(L,1,"Name")

J.SO(TQ.FindObject(lua_tostring(L,2)),False)
Case "TileVisible"
lua_pushboolean(L,V.D.MapData[ lua_tonumber(L,1),lua_tonumber(L,2),1 ] = TD.VISIBLE)

Return 1
Case "RemoveFromMap"
lua_getfield(L,1,"Name")

Local Q:TQ = TQ.FindObject(lua_tostring(L,2))

If Q Then Q.D.RemoveObject(Q)
Case "KeyHit"
lua_pushboolean(L,KeyStroke[ lua_tointeger(L,1) ])

Return 1
Case "SwitchObjects"
lua_getfield(L,1,"Name")
lua_getfield(L,2,"Name")

Local G1:TQ = TQ.FindObject(lua_tostring(L,3))
Local G2:TQ = TQ.FindObject(lua_tostring(L,4))

If G1 And G2 Then
Local TileX% = G1.TileX
Local TileY% = G1.TileY

G1.TileX = G2.TileX
G1.TileY = G2.TileY
G2.TileX = TileX
G2.TileY = TileY

G1.D.PO(G1)
G2.D.PO(G2)

J.SO(G1,True)
J.SO(G2,True)
EndIf
Case "SetMapData"
Local X% = lua_tointeger(L,1)
Local Y% = lua_tointeger(L,2)

For Local I% = 1 To 4
V.D.MapData[ X,Y,I ] = lua_tointeger(L,2 + I)
Next
Case "GetMapData"
Local X% = lua_tointeger(L,1)
Local Y% = lua_tointeger(L,2)

For Local I% = 0 To 4
lua_pushinteger(L,V.D.MapData[ X,Y,I ])
Next

lua_pushinteger(L,V.D.Width)
lua_pushinteger(L,V.D.Height)
lua_pushinteger(L,CurrDepth)

Return 8
End Select
End Function

Type TJ
Field R:Byte Ptr

Method New()
R = luaL_newstate()

luaL_openlibs(R)

lua_pushcfunction(R,ContainerFunc)
lua_setglobal(R,"ContainerFunc")
End Method

Method LoadScenario()
Local S:TBank = LoadBank("ChaosHack")
Local B:TBank = CreateBank(150*1024)

Local L% = 150*1024

Local P1:Byte Ptr = LockBank(S)
Local P2:Byte Ptr = LockBank(B)

uncompress(P2,L,P1,S.Size())

If luaL_loadbuffer(R,P2,L,"ChaosHack") Then Print lua_tostring(R,-1)

If lua_pcall(R,0,0,0 ) Then ThrowScriptError(lua_tostring(R,-1))
End Method

Method ThrowScriptError(Error$)
Throw Error
End Method

Method ReadStringArray$[]()
Local Values$[]

Local Index% = lua_gettop(R)

Local Length% = lua_objlen(R,Index)

For Local I% = 1 To Length
lua_pushnumber(R,I)

lua_gettable(R,Index)

Values :+ [ lua_tostring(R,-1) ]
Next

lua_settop(R,Index)

Return Values
End Method

Method SO(O:TQ,Mode%)
Local ID:TTypeId = TTypeId.ForName("TQ")

lua_getglobal(R,O.Name)

Local Index% = lua_gettop(R)

For Local F:TField = EachIn ID.EnumFields()
If Mode Then
Select F.TypeID().Name()
Case "Int"
lua_pushinteger(R,F.GetInt(O))
Case "Float"
lua_pushnumber(R,F.GetFloat(O))
Case "String"
lua_pushstring(R,F.GetString(O))
Default
Continue
End Select

lua_setfield(R,Index,F.Name())
Else
Select F.TypeID().Name()
Case "Int","Float","String"
Local N$ = F.Name()

If N <> "TileX" And N <> "TileY" Then
lua_getfield(R,Index,N)

If Not lua_isnil(R,-1) Then F.Set(O,lua_tostring(R,-1))

lua_pop(R,1)
EndIf
End Select
EndIf
Next

lua_pop(R,1)
End Method

Method CallObjectMethod(O:TQ,Name$)
SO(O,True)

lua_getglobal(R,O.Name)
lua_getfield(R,-1,Name)

If lua_isnil(R,-1) Then
lua_pop(R,2)
Else
lua_insert(R,lua_gettop(R) - 1)

If lua_pcall(R,1,0,0) Then ThrowScriptError(lua_tostring(R,-1))
EndIf

SO(O,False)
End Method
End Type

Type TScenario
Global Walls%[]
Global StairUp%
Global StairDown%
Global Hero%

Global Levels:TLevel[]

Global Difficulty:TD

Global SurfaceS$

Function Load()
Levels = Null
Walls  = [ 35,95,124,47,92,37,38 ]

TLevel.CurrD = Null

J.LoadScenario()

Local L:Byte Ptr = J.R

lua_getglobal(L,"Scenario")

Local Index% = lua_gettop(L)

For Local I$ = EachIn [  "Difficulty","Surface" ]
lua_getfield(L,Index,I)
Next

StairUp	= 94
StairDown	= 118
Hero		= 72
Difficulty	= TD.Create(lua_tostring(L,Index + 1))
SurfaceS	= lua_tostring(L,Index + 2)

lua_settop(L,Index - 1)
End Function

Function LoadLevels:TD(Difficulty%)
Local L:Byte Ptr = J.R

lua_getglobal(L,"Scenario")

lua_getfield(L,-1,"Levels")
lua_pushinteger(L,Difficulty)
lua_gettable(L,-2)

For Local I$ = EachIn J.ReadStringArray()
Levels :+ [ TLevel.Create(I) ]
Next

TQ.ObjectList.Clear()

Return TD.Create(SurfaceS)
End Function
End Type

Type TLevel
Global CurrD:TD

Field Name$

Method CreateD:TD()
Local L:Byte Ptr = J.R

lua_getglobal(L,Name)

lua_getfield(L,-1,"CreateDungeon")

lua_pushinteger(L,CurrDepth)

If lua_pcall(L,1,1,0) Then J.ThrowScriptError(lua_tostring(L,-1))

Local MapData$ = lua_tostring(L,-1)

lua_pop(L,1)

Local D:TD = TD.Create(MapData,V.D)

If CurrD Then
D.MapObjects = CurrD.MapObjects

For Local Q:TQ = EachIn TQ.ObjectList
If Q.D = CurrD Then Q.D = D
Next

CurrD = Null
EndIf

Return D
End Method

Function Create:TLevel(Name$)
Local Level:TLevel = New TLevel

Level.Name = Name

Return Level
End Function
End Type

Type TQ
Global Counter%

Global ObjectList:TList = New TList
Global ObjectMap :TMap  = New TMap

Field HP# = 10

Field D:TD

Field Name$
Field Char$

Field TileX%
Field TileY%

Field MoveX%
Field MoveY%

Method New()
ObjectList.AddFirst(Self)
End Method

Method Render(X%,Y%)
SetColor 255,0,0
DrawText Char,X*9,Y*TD.TILESIZE

SetColor 0,255,0
DrawText Char,TileX*9,TileY*TD.TILESIZE
End Method

Method Update()
If HP <= 0.0 Then
ObjectList.Remove(Self)
ObjectMap .Remove(Name)

D.RemoveObject(Self)

If Self = V Then Cls

J.CallObjectMethod(Self,"Death")

lua_pushnil  (J.R)
lua_setglobal(J.R,Name)

If Self = V Then
Flip 0
Delay 1000
WaitKey()

ObjectList = New TList
ObjectMap  = New TMap
Counter    = 0
D    = Null

Init()
EndIf
ElseIf Upper(Char) = Char Then
J.CallObjectMethod(Self,"Update")

D.MoveObject(Self,TileX + MoveX,TileY + MoveY)

J.SO(Self,True)
EndIf
End Method

Function FindObject:TQ(Name$)
Return TQ(ObjectMap.ValueForKey(Name))
End Function

Function UpdateAll()
For Local Q:TQ = EachIn ObjectList
If Q.D = V.D Then Q.Update()
Next
End Function

Function CreateFromLua:TQ(Name$,D:TD = Null)
If Not D Then D = V.D

Local Q:TQ = New TQ
Q.Name    = Name + Counter
Q.D = D

Counter :+ 1

Local L:Byte Ptr = J.R

lua_getglobal(L,"CopyObject")
lua_getglobal(L,Name)

If lua_pcall(L,1,1,0) Then J.ThrowScriptError(lua_tostring(L,-1))

lua_setglobal(L,Q.Name)

J.SO(Q,False)
J.SO(Q,True )

ObjectMap .Insert (Q.Name,Q)

Return Q
End Function
End Type

Type TV Extends TQ
Method New()
Char = Chr(TScenario.Hero)

Name = "Hero"

ObjectMap.Insert("Hero",Self)
End Method

Method UserInput()
Local MoveX% = KeyStroke[ KEY_RIGHT ] - KeyStroke[ KEY_LEFT ]
Local MoveY% = KeyStroke[ KEY_DOWN  ] - KeyStroke[ KEY_UP   ]

If Not D.MoveObject(Self,TileX + MoveX,TileY + MoveY) Then
If TileX = D.UpStairs[ 0 ] And TileY = D.UpStairs[ 1 ] Then
Local NewD:TD = D.MoveUp()

If D = NewD.LeftChild Then
NewD.MoveObject(Self,NewD.LeftStairs[ 0 ],NewD.LeftStairs[ 1 ])
Else
NewD.MoveObject(Self,NewD.RightStairs[ 0 ],NewD.RightStairs[ 1 ])
EndIf

D = NewD

If CurrDepth Then CurrDepth :- 2
ElseIf TileX = D.LeftStairs[ 0 ] And TileY = D.LeftStairs[ 1 ] Then
D = D.MoveLeft()

D.MoveObject(Self,D.UpStairs[ 0 ],D.UpStairs[ 1 ])
ElseIf TileX = D.RightStairs[ 0 ] And TileY = D.RightStairs[ 1 ] Then
D = D.MoveRight()

D.MoveObject(Self,D.UpStairs[ 0 ],D.UpStairs[ 1 ])
EndIf

CurrDepth :+ 1
EndIf

UpdateWorld()
End Method

Method UpdateWorld()
Cls

UpdateAll()

If D Then D.Render()

Flip 0
End Method

Function Create:TV(X%,Y%,D:TD)
V = New TV
V.TileX = X
V.TileY = Y
V.D = D

D.PO(V)

Return V
End Function
End Type

Type TD
Const UNKNOWN%		= 1
Const OCCLUDED%	= 2
Const VISIBLE%		= 3

Const TILESIZE%	= 15

Field Parent    :TD
Field LeftChild :TD
Field RightChild:TD

Field UpStairs   %[ 2 ]
Field LeftStairs %[ 2 ]
Field RightStairs%[ 2 ]

Field Width%
Field Height%

Field MapData:Byte[,,]
Field MapObjects:TQ[,]

Method IsWall%(X%,Y%)
For Local I:Byte = EachIn TScenario.Walls
If I = MapData[ X,Y,0 ] Then Return True
Next

Return False
End Method

Method MoveUp:TD()
If Not CurrDepth Then Return TScenario.LoadLevels(3)

RemoveObject(V)

Return Parent
End Method

Method MoveLeft:TD()
If Not CurrDepth Then Return TScenario.LoadLevels(2)

If Not LeftChild Then LeftChild = TScenario.Levels[ CurrDepth - 1 ].CreateD()

RemoveObject(V)

Return LeftChild
End Method

Method MoveRight:TD()
If Not CurrDepth Then Return TScenario.LoadLevels(1)

If Not RightChild Then RightChild = TScenario.Levels[ CurrDepth - 1 ].CreateD()

RemoveObject(V)

Return RightChild
End Method

Method Render()
For Local Y% = 0 To Height - 1
For Local X% = 0 To Width - 1
If MapObjects[ X,Y ] And MapData[ X,Y,1 ] = VISIBLE Then
MapObjects[ X,Y ].Render(X,Y)
Else
SetColor MapData[ X,Y,2 ],MapData[ X,Y,3 ],MapData[ X,Y,4 ]
DrawText Chr(MapData[ X,Y,0 ]),X*9,Y*TILESIZE
EndIf
Next
Next
End Method

Method PO(Q:TQ)
MapObjects[ Q.TileX,Q.TileY ] = Q
End Method

Method MoveObject%(Q:TQ,NewX%,NewY%)
If MapObjects[ NewX,NewY ] Then
If Q = V Then J.CallObjectMethod(MapObjects[ NewX,NewY ],"BumpInto")
ElseIf Not IsWall(NewX,NewY)
If Q.TileX < Width And Q.TileY < Height Then ..
MapObjects[ Q.TileX,Q.TileY ] = Null

Q.TileX = NewX
Q.TileY = NewY

PO(Q)

If MapData[ NewX,NewY,0 ] = TScenario.StairUp Or MapData[ NewX,NewY,0 ] = TScenario.StairDown Then
Return False
Else
Return True
EndIf
EndIf

Return True
End Method

Method RemoveObject(Q:TQ)
MapObjects[ Q.TileX,Q.TileY ] = Null
End Method

Function Prepare:TD(Width%,Height%)
Local D:TD = New TD
D.MapObjects = New TQ[ Width,Height ]

Return D
End Function

Function Create:TD(MapData$,Parent:TD = Null)
Local Rows$[] = MapData.Replace("~r","").Split("~n")

Local D:TD = New TD
D.Parent     = Parent
D.Height     = Rows.Length
D.Width      = Rows[ 0 ].Length
D.MapData    = New Byte[ D.Width,D.Height,5 ]
D.MapObjects = New TQ[ D.Width,D.Height ]

For Local Y% = 0 To D.Height - 1
For Local X% = 0 To D.Width - 1
If Rows[ Y ][ X ] = TScenario.Hero Then
TV.Create(X,Y,D)

D.MapData[ X,Y,0 ] = Asc(".")
Else
D.MapData[ X,Y,0 ] = Rows[ Y ][ X ]

Select Rows[ Y ][ X ]
Case TScenario.StairUp
D.UpStairs[ 0 ] = X
D.UpStairs[ 1 ] = Y
Case TScenario.StairDown
If D.LeftStairs[ 0 ] Then
D.RightStairs[ 0 ] = X
D.RightStairs[ 1 ] = Y
Else
D.LeftStairs[ 0 ] = X
D.LeftStairs[ 1 ] = Y
EndIf
End Select
EndIf

D.MapData[ X,Y,1 ] = UNKNOWN
Next
Next

Return D
End Function
End Type